import numpy as np
import sys

# Cargamos las elipses
A1 = np.load( "A1.npy" )
A2 = np.load( "A2.npy" )

#      a   b/2  d/2 
# A = b/2   c   e/2
#      d/2  e/2   f

print( A1 )
print( A2 )

beta1 = A2[2,2]/A1[2,2]
print( "beta1=", beta1 )

beta3 = beta1 * (1/0.5)*(1/0.5) 
print( "beta3=", beta3 )

A1inv = np.linalg.inv( A1 )
A2inv = np.linalg.inv( A2 )
A = A1 @ A2inv
e, E = np.linalg.eig( A )
print( e )
print( E )

v = abs( e - np.median(e) )
i_raiz_repetida = np.argmin(v)
i_raiz_unica = np.argmax(v)
# print( i_raiz_repetida, i_raiz_unica )

beta1 = e[i_raiz_repetida]
beta3 = e[i_raiz_unica]

G1 = beta1*A1inv - A2inv
e1, E1 = np.linalg.eig( G1 )
indice = np.argmax(e)
h3 = E1[:,indice]*np.sqrt( e[indice] )
h3 = h3.reshape( (3,1) )


G2 = beta3*A1inv - A2inv
e2, E2 = np.linalg.eig( G2 )
# print( e2 )
# print( E2 )
h1 = E2[:,0]*np.sqrt( e[0] )
h1 = h1.reshape( (3,1) )
h2 = E2[:,1]*np.sqrt( e[1] )
h2 = h2.reshape( (3,1) )
# print( h2.shape )

H = np.zeros( (3,3) )
H[:,0] = h1[:,0]
H[:,1] = h2[:,0]
H[:,2] = h3[:,0]

u0 = 300
v0 = 200
f2 = ( u0 * ( H[0,1] * H[2,0] + H[2,1]*H[0,0] - u0*H[2,1]*H[2,0] ) + v0*( H[1,1]*H[2,0] +
     H[2,1]*H[1,0] - v0*H[2,1]*H[2,0] ) - H[0,1]*H[0,0] - H[1,1]*H[1,0] )/ (H[2,1]*H[2,0])

f2 = np.sqrt(f2)
print( "f=", f2 )

